VERSION 4.00
Begin VB.Form frmIndex 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Keyword Index"
   ClientHeight    =   5565
   ClientLeft      =   1200
   ClientTop       =   1590
   ClientWidth     =   6735
   Height          =   5970
   Icon            =   "index.frx":0000
   Left            =   1140
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5565
   ScaleWidth      =   6735
   ShowInTaskbar   =   0   'False
   Top             =   1245
   Width           =   6855
   Begin VB.ComboBox dlbIndex 
      BackColor       =   &H00FFFFFF&
      Height          =   315
      ItemData        =   "index.frx":000C
      Left            =   4200
      List            =   "index.frx":000E
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   360
      Width           =   2415
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   5400
      TabIndex        =   5
      Top             =   4800
      Width           =   1215
   End
   Begin VB.CommandButton cmdGoto 
      Caption         =   "Go To"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   375
      Left            =   5400
      TabIndex        =   4
      Top             =   4320
      Width           =   1215
   End
   Begin VB.ListBox lbTopicList 
      Height          =   1035
      Left            =   120
      TabIndex        =   3
      Top             =   4320
      Width           =   4935
   End
   Begin VB.ListBox lbKeywordList 
      Height          =   2400
      Left            =   120
      TabIndex        =   1
      Top             =   1080
      Width           =   3735
   End
   Begin VB.TextBox txtKeyword 
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   3735
   End
   Begin VB.Label lblIndex 
      Caption         =   "Keyword &Index:"
      Height          =   255
      Left            =   4200
      TabIndex        =   9
      Top             =   105
      Width           =   1575
   End
   Begin VB.Line Line1 
      X1              =   120
      X2              =   6600
      Y1              =   3840
      Y2              =   3840
   End
   Begin VB.Label lblTopicList 
      Caption         =   "&Topics Containing Keyword:"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   4065
      Width           =   2295
   End
   Begin VB.Label lblKeywordList 
      Caption         =   "Keyword &List:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   825
      Width           =   1095
   End
   Begin VB.Label lblKeyword 
      Caption         =   "Type a &keyword or select one from the Keyword List:"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   105
      Width           =   3855
   End
End
Attribute VB_Name = "frmIndex"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

' We only keep one Word Wheel open at a time, and it is used
' throughout the procedures in this form, so we make it global
Dim hWordWheel As Long

Private Sub cmdCancel_Click()

    Unload Me

End Sub


Private Sub cmdGoto_Click()

    Dim va As Long
    
    'Store the current Topic Title, Index, VA and Scroll position
    StoreTopicInfo
    
    ' Convert the topic's Addr into a Va
    va = vaMVConvertAddr(frmMain.mvMain.hTitle, lbTopicList.ItemData(lbTopicList.NewIndex))
    
    ' Jump to the topic
    frmMain.mvMain.SetTopicVA va, 0
    
    ' Unload the form
    Unload Me

End Sub


Private Sub dlbIndex_Click()
    
    ' Fill the Keyword List with new keywords
    Call KeywordsFromIndex(Indexes(dlbIndex.ListIndex).Filename)

End Sub


Private Sub Form_Load()
    
    Dim nIndex As Integer
    
    ' Center the form on the screen (False to center on app)
    Call CenterForm(Me, False)

    ' Fill the Keyword Index dropdown list box
    For nIndex = 0 To (UBound(Indexes) - 1)
        dlbIndex.AddItem Indexes(nIndex).Title
    Next nIndex

    ' Select the first item in the list (this causes a click event
    ' in the list box which fills the Keyword List with keywords)
    dlbIndex.ListIndex = 0

End Sub



Public Sub KeywordsFromIndex(wwFile As String)
    
    Dim numWords As Long
    Dim i As Long
    Dim nTemp As Integer
    Dim szKeyword As String
    
    ' The keywords are stored in a Word Wheel, so open the one we want
    hWordWheel = hMVWordWheelOpenTitle(frmMain.mvMain.hTitle, "|" & wwFile)
    If hWordWheel = 0 Then
        ' Display an error message
        Call MsgBox("Unable to open Word Wheel " & Chr$(34) & _
            wwFile & Chr$(34) & ".", vbExclamation, "Keyword Index")
        Exit Sub
    End If
    
    ' Clear the Keyword List
    lbKeywordList.Clear
    ' Clear the Topic List and disable the Goto button
    lbTopicList.Clear
    cmdGoto.Enabled = False
    
    ' Initialize the string
    szKeyword = String(261, 0)
    
    ' Fill the Keyword List with the keywords for this index
    numWords = lMVWordWheelLength(hWordWheel)
    If numWords = -1 Then
        ' Display an error message
        Call MsgBox("Unable to get Word Wheel length.", vbExclamation, "Keyword Index")
        Exit Sub
    End If
    For i = 0 To (numWords - 1)
        ' Get each keyword (they are already alphabetized)
        nTemp = nMVWordWheelLookup(hWordWheel, i, szKeyword, Len(szKeyword))
        If nTemp <> 0 Then
            ' Display an error message
            Call MsgBox("Unable to look up keyword for Word Wheel at index " _
                & i & ".", vbExclamation, "Keyword Index")
            Exit Sub
        End If
        ' Add it to the Keyword List list box
        lbKeywordList.AddItem szKeyword
    Next i
    
End Sub

Public Sub TopicsFromKeyword(szKeyword As String)

    Dim lTopicCount As Long
    Dim lTemp As Long
    Dim lTopicAddr() As Long
    Dim i As Integer
    Dim szTopicTitle As String
    
    ' Get the number of topics in which this keyword can be found
    lTopicCount = nMVKeyIndexGetCount(hWordWheel, szKeyword)
    If lTopicCount = -1 Then
        ' Display an error message
        Call MsgBox("Unable to get topic count for keyword " & Chr$(34) & _
            szKeyword & Chr$(34) & ".", vbExclamation, "Keyword Index")
        Exit Sub
    End If
        
    ' Clear the Topic List and disable the Goto button
    lbTopicList.Clear
    cmdGoto.Enabled = False
    
    ' ReDim the array of topic addrs to the count found above
    ReDim lTopicAddr(lTopicCount)
    
    ' Fill the array with topic addrs
    lTemp = lMVKeyIndexGetAddrs(hWordWheel, szKeyword, 0, lTopicCount, lTopicAddr(0))
    If lTemp <= 0 Then
        ' Display an error message
        Call MsgBox("Unable to get topic addresses for keyword " & Chr$(34) & _
            szKeyword & Chr$(34) & ".", vbExclamation, "Keyword Index")
        Exit Sub
    End If

    ' Fill the Topic List with topic titles
    For i = 0 To (lTopicCount - 1)
        szTopicTitle = String(128, 0)
        lTemp = lMVTitleGetInfo(frmMain.mvMain.hTitle, TTLINF_ADDRTITLE, lTopicAddr(i), szTopicTitle)
        If lTemp <> 0 Then
            ' Display an error message
            Call MsgBox("Unable to get topic title for address " & _
                lTopicAddr(i) & ".", vbExclamation, "Keyword Index")
            Exit Sub
        End If
        ' If there is no topic title, provide a generic one
        If szTopicTitle = "" Then szTopicTitle = "<Untitled Topic>"
        ' Add the item to the Topic List
        lbTopicList.AddItem szTopicTitle
        ' Associate the Topic's addr with the new list item
        lbTopicList.ItemData(lbTopicList.NewIndex) = lTopicAddr(i)
    Next i

End Sub




Private Sub lbKeywordList_Click()

    ' Get the topics in which the selected keyword can be found
    Call TopicsFromKeyword(lbKeywordList.List(lbKeywordList.ListIndex))

End Sub


Private Sub lbTopicList_Click()

    ' Now that a topic is selected, it's OK to "Go To"
    cmdGoto.Enabled = True

End Sub


Private Sub lbTopicList_DblClick()

    ' Go to the topic that was double clicked
    cmdGoto_Click

End Sub


Private Sub txtKeyword_Change()

    ' As long as there's text in the text box ...
    If txtKeyword.Text <> "" Then
        ' Select the closest match in the Keyword List
        lbKeywordList.ListIndex = lMVWordWheelPrefix(hWordWheel, txtKeyword.Text)
    End If

End Sub

